/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Manager.h"
#include "com_phidget22_ManagerBase.h"

static jclass manager_class;
jfieldID manager_handle_fid;

static jclass attachEvent_class;
static jmethodID fireAttach_mid	;
static jmethodID attachEvent_cons;
static jfieldID nativeAttachHandler_fid;

static jclass detachEvent_class;
static jmethodID fireDetach_mid	;
static jmethodID detachEvent_cons;
static jfieldID nativeDetachHandler_fid;

void com_phidget22_ManagerBase_OnLoad(JNIEnv *env) {
	if (!(manager_class = (*env)->FindClass(env, "com/phidget22/ManagerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerBase");
	if (!(manager_class = (jclass)(*env)->NewGlobalRef(env, manager_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef manager_class");
	if (!(manager_handle_fid = (*env)->GetFieldID(env, manager_class, "handle", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID handle from manager_class");

	if (!(attachEvent_class = (*env)->FindClass(env, "com/phidget22/ManagerAttachEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerAttachEvent");
	if (!(attachEvent_class = (jclass)(*env)->NewGlobalRef(env, attachEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref AttachEvent_class");
	if (!(fireAttach_mid = (*env)->GetMethodID(env, manager_class, "fireAttach", "(Lcom/phidget22/ManagerAttachEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireAttach");
	if (!(attachEvent_cons = (*env)->GetMethodID(env, attachEvent_class, "<init>", "(Lcom/phidget22/Manager;Lcom/phidget22/Phidget;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from AttachEvent_class");
	if (!(nativeAttachHandler_fid = (*env)->GetFieldID(env, manager_class, "nativeAttachHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeAttachHandler from manager_class");

	if (!(detachEvent_class = (*env)->FindClass(env, "com/phidget22/ManagerDetachEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/ManagerDetachEvent");
	if (!(detachEvent_class = (jclass)(*env)->NewGlobalRef(env, detachEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref DetachEvent_class");
	if (!(fireDetach_mid = (*env)->GetMethodID(env, manager_class, "fireDetach", "(Lcom/phidget22/ManagerDetachEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireDetach");
	if (!(detachEvent_cons = (*env)->GetMethodID(env, detachEvent_class, "<init>", "(Lcom/phidget22/Manager;Lcom/phidget22/Phidget;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from DetachEvent_class");
	if (!(nativeDetachHandler_fid = (*env)->GetFieldID(env, manager_class, "nativeDetachHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeDetachHandler from manager_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_ManagerBase_create(JNIEnv * env, jclass obj) {
	PhidgetManagerHandle phid;
	int error; 
	if ((error = PhidgetManager_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}
JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_delete(JNIEnv * env, jclass obj) {
	PhidgetManagerHandle h = (PhidgetManagerHandle)(uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	int error; 
	if ((error = PhidgetManager_delete(&h)) != EPHIDGET_OK)
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_close(JNIEnv * env, jobject obj) {
	PhidgetManagerHandle h = (PhidgetManagerHandle)(uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	int error;
	if ((error = PhidgetManager_close(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_open(JNIEnv * env, jobject obj) {
	PhidgetManagerHandle h = (PhidgetManagerHandle)(uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	int error;
	if ((error = PhidgetManager_open(h)))
		PH_THROW(error);
}

static void CCONV attach_handler(PhidgetManagerHandle h, void *arg, PhidgetHandle channel) {
	JNIEnv *env;
	jobject obj;
	jobject attachEv;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if (!(attachEv = (*env)->NewObject(env, attachEvent_class, attachEvent_cons, obj, (*env)->NewObject(env, phid_class, phid_cons, channel))))
		return;

	(*env)->CallVoidMethod(env, obj, fireAttach_mid, attachEv);
	(*env)->DeleteLocalRef(env, attachEv);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_enableAttachEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeAttachHandler_fid, b);
	PhidgetManagerHandle h = (PhidgetManagerHandle)( uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	PhidgetManager_setOnAttachHandler(h, b ? attach_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV detach_handler(PhidgetManagerHandle h, void *arg, PhidgetHandle channel) {
	JNIEnv *env;
	jobject obj;
	jobject detachEv;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if (!(detachEv = (*env)->NewObject(env, detachEvent_class, detachEvent_cons, obj, (*env)->NewObject(env, phid_class, phid_cons, channel))))
		return;

	(*env)->CallVoidMethod(env, obj, fireDetach_mid, detachEv);
	(*env)->DeleteLocalRef(env, detachEv);
}

JNIEXPORT void JNICALL Java_com_phidget22_ManagerBase_enableDetachEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeDetachHandler_fid, b);
	PhidgetManagerHandle h = (PhidgetManagerHandle)( uintptr_t)(*env)->GetLongField(env, obj, manager_handle_fid);
	PhidgetManager_setOnDetachHandler(h, b ? detach_handler : NULL, (void *)(uintptr_t) gr);
}
